
% Finite difference method:
% Approximate the solution of        y"= -y' -y + z        &        z"= z' + z - y
% Approximate the solution of   y"= p(x)y'+ q(x)y + r(x)z  &  z"= p'(x)z' + q'(x)z + r'(x)y
% x=0  y'=1 , z=1
% x=L  z'=1 , y=1
 
clc;
clear;
close all;

%-----------Inpute------------
 A=1; B=1; C=1; D=1; K=1;
 p = @(x) (-A/B);  
 q = @(x) (-K/B/D);
 r = @(x) (K/B);
 pprim = @(x) (C/D);  
 qprim = @(x) (K/D);
 rprim = @(x) (-K/D);
 
 
 aaa = 0;   % x=0 
 bbb = 1;   % x=L 
 alpha = 1;
 beta = 1;
 gama=1;
 deltha=1;
 n=29;     
%-----------------------------

 fprintf('   x           w             ww   \n');
 h = (bbb-aaa)/(n+1);
 a = zeros(1,n+1);
 b = zeros(1,n+1);
 c = zeros(1,n+1);
 d = zeros(1,n+1);
 l = zeros(1,n+1);
 u = zeros(1,n+1);
 z = zeros(1,n+1);
 w = zeros(1,n+1);
 x = aaa+h;
 
 aa = zeros(1,n+1);
 bb = zeros(1,n+1);
 cc = zeros(1,n+1);
 dd = zeros(1,n+1);
 ll = zeros(1,n+1);
 uu = zeros(1,n+1);
 zz = zeros(1,n+1);
 ww = zeros(1,n+1);
 xx = bbb+h;
 
 a(1) = 2+h^2*q(x);
 b(1) = -1+0.5*h*p(x);
 d(1) = -h^2*r(x)+(1+0.5*h*p(x))*alpha;
 
 aa(1) = 2+h^2*qprim(x);
 bb(1) = -1+0.5*h*pprim(x);
 dd(1) = -h^2*rprim(x)+(1+0.5*h*pprim(x))*gama;

 m = n-1;
 
 for i = 2 : m 
   x = aaa+i*h;
   a(i) = 2+h^2*q(x);
   b(i) = -1+0.5*h*p(x);
   c(i) = -1-0.5*h*p(x);
   d(i) = -h^2*r(x);
   
   aa(i) = 2+h^2*qprim(x);
   bb(i) = -1+0.5*h*pprim(x);
   cc(i) = -1-0.5*h*pprim(x);
   dd(i) = -h^2*rprim(x);
 end
 
 x = bbb-h;
 a(n) = 2+h^2*q(x);
 c(n) = -1-0.5*h*p(x);
 d(n) = -h^2*r(x)+(1-0.5*h*p(x))*beta;
 l(1) = a(1);
 u(1) = b(1)/a(1);
 z(1) = d(1)/l(1);
 
 aa(n) = 2+h^2*qprim(x);
 cc(n) = -1-0.5*h*pprim(x);
 dd(n) = -h^2*rprim(x)+(1-0.5*h*pprim(x))*deltha;
 ll(1) = aa(1);
 uu(1) = bb(1)/aa(1);
 zz(1) = dd(1)/ll(1);
 
 for i = 2 : m 
   l(i) = a(i)-c(i)*u(i-1);
   u(i) = b(i)/l(i);
   z(i) = (d(i)-c(i)*z(i-1))/l(i);
   
   ll(i) = aa(i)-cc(i)*uu(i-1);
   uu(i) = bb(i)/ll(i);
   zz(i) = (dd(i)-cc(i)*zz(i-1))/ll(i);
 end
 
 l(n) = a(n)-c(n)*u(n-1);
 z(n) = (d(n)-c(n)*z(n-1))/l(n);
 w(n) = z(n);

 ll(n) = aa(n)-cc(n)*uu(n-1);
 zz(n) = (dd(n)-cc(n)*zz(n-1))/ll(n);
 ww(n) = zz(n);
 
 for j = 1 : m 
   i = n-j;
   w(i) = z(i)-u(i)*w(i+1);
   ww(i) = zz(i)-uu(i)*ww(i+1);
 end
 
 i = 0;
 fprintf('%5.4f    %11.8f\n   %11.8f\n', aaa, alpha, gama);
 for i = 1 : n 
   x = aaa+i*h;
   fprintf('%5.4f    %11.8f\n   %11.8f\n', x, w(i), ww(i));
 end
 i = n+1;
 fprintf('%5.4f    %11.8f\n    %11.8f\n', bbb, beta, gama);
 